Index: /events/src/test/java/geniusweb/actions/VotesTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VotesTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/VotesTest.java	(revision 26)
@@ -0,0 +1,147 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VotesTest extends GeneralTests<Votes> {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private final String votestring = "{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2,\"maxPower\":9}},{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2,\"maxPower\":9}}]}}";
+
+	private PartyId partyA = new PartyId("partyA");
+	private PartyId partyB = new PartyId("partyB");
+	private Bid bid1 = new Bid("is1", new DiscreteValue("val1")),
+			bid2 = new Bid("is1", new DiscreteValue("val2"));
+	private Vote voteA1 = new Vote(partyA, bid1, 2, 9);
+	private Vote voteA2 = new Vote(partyA, bid2, 2, 9);
+	private Vote voteB1 = new Vote(partyB, bid1, 2, 9);
+	private Vote voteB2 = new Vote(partyB, bid2, 2, 9);
+
+	private Votes votes1 = new Votes(partyA,
+			new HashSet<>(Arrays.asList(voteA1, voteA2)));
+	private Votes votes1a = new Votes(partyA,
+			new HashSet<>(Arrays.asList(voteA1, voteA2)));
+	private Votes votes2 = new Votes(partyB,
+			new HashSet<>(Arrays.asList(voteB1, voteB2)));
+
+	@Override
+	public List<List<Votes>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(votes1, votes1a),
+				Arrays.asList(votes2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Votes.*Vote.*partyA,Bid.*is1.*val1.*2.*Vote.*partyA,Bid.*is1.*val2.*2.*",
+				"Votes.*Vote.*partyB,Bid.*is1.*val2.*2.*Vote.*partyB,Bid.*is1.*val1.*2.*");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRejectVoteWithIncorrectParty() {
+		new Votes(partyA, Collections.singleton(voteB1));
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(votes1));
+		assertEquals(votestring, jackson.writeValueAsString(votes1));
+	}
+
+	@Test
+	public void deserializeTest() throws IOException {
+		Action act = jackson.readValue(votestring, Action.class);
+		assertEquals(votes1, act);
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWrongPartyName() {
+		new Votes(partyA, new HashSet<>(Arrays.asList(voteB1, voteB2)));
+	}
+
+	@Test
+	public void isExtendingTestExtraVote() {
+		Votes otherVotes = new Votes(partyA, Collections.singleton(voteA1));
+		assertTrue(votes1.isExtending(otherVotes));
+	}
+
+	@Test
+	public void isExtendingTestNoVotes() {
+		Votes otherVotes = new Votes(partyA, Collections.emptySet());
+		assertTrue(votes1.isExtending(otherVotes));
+	}
+
+	@Test
+	public void isExtendingTestMissing() {
+		Votes otherVotes = new Votes(partyA, Collections.singleton(voteA1));
+		assertFalse(otherVotes.isExtending(votes1));
+	}
+
+	@Test
+	public void isExtendingIdenticalVotes() {
+		assertTrue(votes1.isExtending(votes1));
+	}
+
+	@Test
+	public void isReallyExtendingVotesMin() {
+		Vote powervoteA1 = new Vote(partyA, bid1, 1, 9);
+		Votes powerVotes = new Votes(partyA,
+				new HashSet<>(Arrays.asList(powervoteA1, voteA2)));
+		assertTrue(powerVotes.isExtending(votes1));
+	}
+
+	@Test
+	public void isReallyExtendingVotesMax() {
+		Vote powervoteA1 = new Vote(partyA, bid1, 2, 10);
+		Votes powerVotes = new Votes(partyA,
+				new HashSet<>(Arrays.asList(powervoteA1, voteA2)));
+		assertTrue(powerVotes.isExtending(votes1));
+	}
+
+	@Test
+	public void IsNarrowingOneVoteRemoved() {
+		Votes narrowVotes = new Votes(partyA, Collections.singleton(voteA2));
+		assertFalse(narrowVotes.isExtending(votes1));
+	}
+
+	@Test
+	public void isNarrowingTestMoreMinPower() {
+		Vote narrowVoteA1 = new Vote(partyA, bid1, 3, 9);
+		Votes narrowVotes = new Votes(partyA,
+				new HashSet<>(Arrays.asList(narrowVoteA1, voteA2)));
+		assertFalse(narrowVotes.isExtending(votes1));
+		assertTrue(votes1.isExtending(narrowVotes));
+	}
+
+	@Test
+	public void isNarrowingLessMaxPower() {
+		Vote powervoteA1 = new Vote(partyA, bid1, 2, 8);
+		Votes narrowVotes = new Votes(partyA,
+				new HashSet<>(Arrays.asList(powervoteA1, voteA2)));
+		assertFalse(narrowVotes.isExtending(votes1));
+		assertTrue(votes1.isExtending(narrowVotes));
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testDuplicateBidsNotAllowed() {
+		Vote voteA1similar = new Vote(partyA, bid1, 3, 9);
+		Votes votes = new Votes(partyA,
+				new HashSet<>(Arrays.asList(voteA1, voteA1similar)));
+	}
+}
Index: /events/src/test/java/geniusweb/events/ActionEventTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/ActionEventTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/events/ActionEventTest.java	(revision 26)
@@ -0,0 +1,71 @@
+package geniusweb.events;
+
+import static org.junit.Assert.assertEquals;
+import static org.mockito.Mockito.mock;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ActionEventTest extends GeneralTests<ActionEvent> {
+	private static final long NOW = 101l;
+	private final ObjectMapper jackson = new ObjectMapper();
+	private final String string = "{\"actionevent\":{\"action\":{\"endnegotiation\":{\"actor\":\"party1\"}},\"time\":101}}";
+	private final PartyId id = new PartyId("party1");
+	private final Action action = new EndNegotiation(id);
+	private final ActionEvent evt = new ActionEvent(action, NOW);
+	private final ActionEvent evt1 = new ActionEvent(action, NOW);
+	private final ActionEvent evtb = new ActionEvent(action, NOW + 1);
+
+	@Override
+	public List<List<ActionEvent>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(evt, evt1), Arrays.asList(evtb));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("ActionEvent\\[.*" + NOW + ".*EndNegotiation.*\\]",
+				"ActionEvent\\[.*" + (NOW + 1) + ".*EndNegotiation.*\\]");
+	}
+
+	@Test
+	public void smoketest() {
+		Action action = mock(EndNegotiation.class);
+		ActionEvent evt = new ActionEvent(action, 0l);
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(evt));
+		assertEquals(string, jackson.writeValueAsString(evt));
+	}
+
+	@Test
+	public void deserializeTestReadActionEvent() throws IOException {
+		ActionEvent evt1 = jackson.readValue(string, ActionEvent.class);
+		// compare fields, as evt is a derived/new inner class
+		assertEquals(EndNegotiation.class, evt1.getAction().getClass());
+		assertEquals((Long) 101l, evt1.getTime());
+	}
+
+	@Test
+	public void deserializeTestReadEvent() throws IOException {
+		NegotiationEvent evt1 = jackson.readValue(string,
+				NegotiationEvent.class);
+		assertEquals(ActionEvent.class, evt1.getClass());
+		ActionEvent ev1 = (ActionEvent) evt1;
+		assertEquals(EndNegotiation.class, ev1.getAction().getClass());
+		assertEquals((Long) 101l, ev1.getTime());
+	}
+
+}
Index: /events/src/test/java/geniusweb/events/SessionStartedTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/SessionStartedTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/events/SessionStartedTest.java	(revision 26)
@@ -0,0 +1,95 @@
+package geniusweb.events;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.junit.Test;
+import org.junit.experimental.theories.DataPoint;
+import org.junit.experimental.theories.DataPoints;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import tudelft.utilities.junit.GeneralTests;
+
+public class SessionStartedTest extends GeneralTests<SessionStarted> {
+
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final Long SESSIONNR = 1l;
+	protected static final Long NOW = (long) 101;
+	protected static final Long NOW1 = NOW + 1;
+
+	private static final PartyId PARTY1 = new PartyId("party1");
+	private static final PartyId PARTY2 = new PartyId("party2");
+
+	private static List<PartyId> parties = Arrays.asList(PARTY1, PARTY2);
+
+	private static final SessionStarted sessionStartedLater = new SessionStarted(
+			SESSIONNR, parties, NOW1);
+	private static final SessionStarted othersessionStarted = new SessionStarted(
+			SESSIONNR + 1, parties, NOW);
+
+	public static SessionStarted sessionStarted = new SessionStarted(SESSIONNR,
+			parties, NOW);
+	private static final SessionStarted sessionStarted1 = new SessionStarted(
+			SESSIONNR, parties, NOW);
+	// jackson expected format.
+	private static String sessionstartedstring = "{\"sessionstarted\":{\"sessionNumber\":1,\"parties\":[\"party1\",\"party2\"],\"time\":101}}";
+	// "{\"sessionstarted\":{\"time\":101,\"sessionNumber\":1,\"parties\":[\"party1\",\"party2\"]}}";
+	public static String expectedstring = "SessionStarted.*101.*";
+
+	@Override
+	public List<List<SessionStarted>> getGeneralTestData() {
+		List<List<SessionStarted>> list = new LinkedList<>();
+		list.add(Arrays.asList(sessionStarted, sessionStarted1));
+		list.add(Arrays.asList(sessionStartedLater));
+		list.add(Arrays.asList(othersessionStarted));
+		return list;
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("SessionStarted.*" + SESSIONNR + ".*" + NOW + ".*",
+				"SessionStarted.*" + SESSIONNR + ".*" + NOW1 + ".*",
+				"SessionStarted.*" + (SESSIONNR + 1) + ".*" + NOW + ".*");
+	}
+
+	@DataPoints("equal")
+	public static SessionStarted[] equal() {
+		return new SessionStarted[] { sessionStarted, sessionStarted1 };
+	}
+
+	@DataPoints("notequal")
+	public static SessionStarted[] notequal() {
+		return new SessionStarted[] { sessionStartedLater,
+				sessionStartedLater };
+	}
+
+	@DataPoint("equalstring")
+
+	@Test
+	public void serializeStartedTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(sessionStarted));
+		assertEquals(sessionstartedstring,
+				jackson.writeValueAsString(sessionStarted));
+	}
+
+	@Test
+	public void deserializeStartedTest() throws IOException {
+		NegotiationEvent evt = jackson.readValue(sessionstartedstring,
+				NegotiationEvent.class);
+		assertEquals(SessionStarted.class, evt.getClass());
+		SessionStarted event = (SessionStarted) evt;
+		// compare fields, as sessionended is a derived/new inner class
+		assertEquals(NOW, event.getTime());
+		assertEquals(SESSIONNR, event.getSessionNumber());
+		assertEquals(2, event.getParties().size());
+	}
+
+}
Index: /events/src/test/java/geniusweb/events/TournamentStartedTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/TournamentStartedTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/events/TournamentStartedTest.java	(revision 26)
@@ -0,0 +1,84 @@
+package geniusweb.events;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import tudelft.utilities.junit.GeneralTests;
+
+public class TournamentStartedTest extends GeneralTests<TournamentStarted> {
+
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final Long SESSIONNR = 1l;
+	protected static final Long NOW = (long) 101;
+	protected static final Long NOW1 = NOW + 1;
+	private static final Long NSESSIONS = 5l;
+
+	private static TournamentStarted tournamentStarted = new TournamentStarted(
+			NSESSIONS, NOW);
+	private static TournamentStarted tournamentStarteda = new TournamentStarted(
+			NSESSIONS, NOW);
+	private TournamentStarted otherTournamentStarted = new TournamentStarted(
+			NSESSIONS + 1, NOW);
+	private TournamentStarted tournamentStartedLater = new TournamentStarted(
+			NSESSIONS, NOW1);
+
+	private String tournamentstartedstring = "{\"tournamentstarted\":{\"time\":101,\"numberOfSessions\":5}}";
+
+	@Override
+	public List<List<TournamentStarted>> getGeneralTestData() {
+		List<List<TournamentStarted>> list = new LinkedList<>();
+		list.add(Arrays.asList(tournamentStarted, tournamentStarteda));
+		list.add(Arrays.asList(otherTournamentStarted));
+		list.add(Arrays.asList(tournamentStartedLater));
+		return list;
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"TournamentStarted\\[.*" + NOW + ".*" + NSESSIONS + ".*\\]",
+				"TournamentStarted\\[.*" + NOW + ".*" + (NSESSIONS + 1)
+						+ ".*\\]",
+				"TournamentStarted\\[.*" + NOW1 + ".*" + NSESSIONS + ".*\\]");
+	}
+
+	@Test
+	public void serializeTournamentStartedTest()
+			throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(tournamentStarted));
+		assertEquals(tournamentstartedstring,
+				jackson.writeValueAsString(tournamentStarted));
+	}
+
+	@Test
+	public void deserializeTournamentStartedTest() throws IOException {
+		NegotiationEvent evt = jackson.readValue(tournamentstartedstring,
+				NegotiationEvent.class);
+		assertEquals(TournamentStarted.class, evt.getClass());
+		TournamentStarted event = (TournamentStarted) evt;
+		// compare fields, as sessionended is a derived/new inner class
+		assertEquals(NSESSIONS, event.getNumberOfSessions());
+		assertEquals(NOW, event.getTime());
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testNullTime() {
+		new TournamentStarted(NSESSIONS, null);
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testNegativeTime() {
+		new TournamentStarted(NSESSIONS, -1l);
+	}
+
+}
Index: /events/src/test/java/geniusweb/inform/ActionDoneTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/ActionDoneTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/ActionDoneTest.java	(revision 26)
@@ -0,0 +1,69 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ActionDoneTest extends GeneralTests<ActionDone> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+
+	private final String actiondonestr = "{\"ActionDone\":{\"action\":{\"endnegotiation\":{\"actor\":\"party1\"}}}}";
+
+	private final static Action act1 = new EndNegotiation(id);
+	private final static Action act2 = new EndNegotiation(id2);
+
+	private final static ActionDone done1 = new ActionDone(act1);
+	private final static ActionDone done1a = new ActionDone(act1);
+	private final static ActionDone done2 = new ActionDone(act2);
+
+	@Override
+	public List<List<ActionDone>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(done1, done1a),
+				Arrays.asList(done2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("ActionDone.*EndNegotiation.*party1.*",
+				"ActionDone.*EndNegotiation.*party2.*");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(done1));
+		assertEquals(actiondonestr, jackson.writeValueAsString(done1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Inform act = jackson.readValue(actiondonestr, Inform.class);
+		assertEquals(done1, act);
+	}
+
+	@Test
+	public void testGet() {
+		assertEquals(act1, done1.getAction());
+	}
+
+}
Index: /events/src/test/java/geniusweb/inform/AgreementsTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/AgreementsTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/AgreementsTest.java	(revision 26)
@@ -0,0 +1,100 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class AgreementsTest extends GeneralTests<Agreements> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private static Bid bid = new Bid(
+			Collections.singletonMap("issue1", VALUE1));
+	private static Bid bid2 = new Bid(
+			Collections.singletonMap("issue2", VALUE1));
+
+	private final String finishedstring = "{\"party1\":{\"issuevalues\":{\"issue1\":\"value1\"}}}";
+
+	private final static Agreements agrees1 = new Agreements(
+			Collections.singletonMap(id, bid));
+	private final static Agreements agrees1a = new Agreements(
+			Collections.singletonMap(id, bid));
+	private final static Agreements agrees2 = new Agreements(
+			Collections.singletonMap(id2, bid));
+	private final static Agreements agrees3 = new Agreements(
+			Collections.singletonMap(id, bid2));
+
+	@Override
+	public List<List<Agreements>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(agrees1, agrees1a),
+				Arrays.asList(agrees2), Arrays.asList(agrees3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Agreements.*party1.*Bid.*issue1.*",
+				"Agreements.*party2.*Bid.*issue1.*",
+				"Agreements.*party1.*Bid.*issue2.*");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(agrees1));
+		assertEquals(finishedstring, jackson.writeValueAsString(agrees1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Agreements act = jackson.readValue(finishedstring, Agreements.class);
+		assertEquals(agrees1, act);
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void testNull() {
+		new Agreements();
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWithAlreadyActed() {
+		agrees1.with(agrees1);
+	}
+
+	@Test
+	public void testWith() {
+		Agreements agrees = agrees1.with(agrees2);
+		assertEquals(bid, agrees.getMap().get(id));
+		assertEquals(bid, agrees.getMap().get(id2));
+	}
+
+	@Test
+	public void testBidConstructor() {
+		Agreements agrees = new Agreements(bid,
+				new HashSet<PartyId>(Arrays.asList(id, id2)));
+		assertEquals(bid, agrees.getMap().get(id));
+		assertEquals(bid, agrees.getMap().get(id2));
+	}
+}
Index: /events/src/test/java/geniusweb/inform/FinishedTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/FinishedTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/FinishedTest.java	(revision 26)
@@ -0,0 +1,76 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class FinishedTest extends GeneralTests<Finished> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private static Bid bid = new Bid(
+			Collections.singletonMap("issue1", VALUE1));
+
+	private final String finishedstring = "{\"Finished\":{\"agreements\":{\"party1\":{\"issuevalues\":{\"issue1\":\"value1\"}}}}}";
+
+	private final static Agreements agrees1 = new Agreements(
+			Collections.singletonMap(id, bid));
+	private final static Agreements agrees2 = new Agreements(
+			Collections.singletonMap(id2, bid));
+
+	private final static Finished finished1 = new Finished(agrees1);
+	private final static Finished finished1a = new Finished(agrees1);
+	private final static Finished finished2 = new Finished(agrees2);
+
+	@Override
+	public List<List<Finished>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(finished1, finished1a),
+				Arrays.asList(finished2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Finished.*party1.*Bid.*",
+				"Finished.*party2.*Bid.*");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(finished1));
+		assertEquals(finishedstring, jackson.writeValueAsString(finished1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Inform act = jackson.readValue(finishedstring, Inform.class);
+		assertEquals(finished1, act);
+	}
+
+	@Test(expected = NullPointerException.class)
+	public void testNull() {
+		new Finished(null);
+	}
+
+}
Index: /events/src/test/java/geniusweb/inform/OptInTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/OptInTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/OptInTest.java	(revision 26)
@@ -0,0 +1,77 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class OptInTest extends GeneralTests<OptIn> {
+
+	private Bid bid1 = new Bid("iss", new DiscreteValue("val1"));
+	private Bid bid2 = new Bid("iss", new DiscreteValue("val2"));
+	private PartyId partyA = new PartyId("partyA");
+	private PartyId partyB = new PartyId("partyB");
+
+	private final Vote voteA1 = new Vote(partyA, bid1, 2, 9);
+	private final Vote voteB1 = new Vote(partyB, bid1, 2, 9);
+	private final Vote voteB2 = new Vote(partyB, bid2, 2, 9);
+
+	private Votes votesA = new Votes(partyA, Collections.singleton(voteA1));
+	private Votes votesB = new Votes(partyB,
+			new HashSet<>(Arrays.asList(voteB1, voteB2)));
+
+	private final OptIn optIn1 = new OptIn(Arrays.asList(votesA, votesB));
+	private final OptIn optIn1a = new OptIn(Arrays.asList(votesA, votesB));
+	private final OptIn optIn2 = new OptIn(Arrays.asList(votesA));
+
+	private String asJson = "{\"OptIn\":{\"votes\":[{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}},{\"Votes\":{\"actor\":\"partyB\",\"votes\":[{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2,\"maxPower\":9}},{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}}]}}";
+
+	@Override
+	public List<List<OptIn>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(optIn1, optIn1a),
+				Arrays.asList(optIn2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"OptIn.*Votes.*Vote.*partyA.*iss.*val1.*2.*Votes.*Vote.*partyB.*iss.*val2.*.*2.*Vote.*partyB.*iss.*val1.*2.*",
+				"OptIn.*Votes.*Vote.*partyA.*iss.*val.*2.*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(optIn1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Inform p = jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(optIn1, p);
+	}
+
+}
Index: /events/src/test/java/geniusweb/inform/SettingsTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/SettingsTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/SettingsTest.java	(revision 26)
@@ -0,0 +1,128 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.Date;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import tudelft.utilities.junit.GeneralTests;
+
+public class SettingsTest extends GeneralTests<Settings> {
+
+	private PartyId id = new PartyId("party1");
+	private PartyId id2 = new PartyId("party2");
+
+	private final String asJson = "{\"Settings\":"
+			+ "{\"id\":\"party1\",\"profile\":\"ws:profile1\","
+			+ "\"protocol\":\"ws:localhost/protocol1\","
+			+ "\"progress\":{\"rounds\":{\"duration\":10,\"currentRound\":0,\"endtime\":999}},"
+			+ "\"parameters\":{}}}";
+
+	private Settings negoinfo1, negoinfo1a;
+	private Settings negoinfo2, negoinfo3, negoinfo4, negoinfo5;
+	private final Date date = new Date(999);
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	@Before
+	public void before() throws URISyntaxException, JsonParseException,
+			JsonMappingException, IOException {
+		// we can't mock because we want to test the serializer
+		ProfileRef profile1 = new ProfileRef(new URI("ws:profile1"));
+		// jackson.readValue(serialized, Profile.class);
+
+		ProtocolRef protocol1 = new ProtocolRef(
+				new URI("ws:localhost/protocol1"));
+		ProtocolRef protocol1a = new ProtocolRef(
+				new URI("ws:localhost/protocol1"));
+		ProtocolRef protocol2 = new ProtocolRef(
+				new URI("ws:localhost/protocol2"));
+		ProgressRounds progress1 = new ProgressRounds(10, 0, date);
+		ProgressRounds progress1a = new ProgressRounds(10, 0, date);
+		ProgressRounds progress2 = new ProgressRounds(12, 0, date);
+
+		Parameters settings1 = new Parameters();
+		Parameters settings2 = new Parameters();
+		settings2.put("a", 1);
+
+		negoinfo1 = new Settings(id, profile1, protocol1, progress1, settings1);
+		negoinfo1a = new Settings(id, profile1, protocol1a, progress1a,
+				settings1);
+		negoinfo2 = new Settings(id, profile1, protocol2, progress1, settings1);
+		negoinfo3 = new Settings(id, profile1, protocol1, progress2, settings1);
+		negoinfo4 = new Settings(id2, profile1, protocol1, progress2,
+				settings1);
+		negoinfo5 = new Settings(id, profile1, protocol1, progress1, settings2);
+	}
+
+	@Override
+	public List<List<Settings>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(negoinfo1, negoinfo1a),
+				Arrays.asList(negoinfo2), Arrays.asList(negoinfo3),
+				Arrays.asList(negoinfo4), Arrays.asList(negoinfo5));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Settings.*party1.*ProtocolRef.*protocol1.*ProgressRounds.*0.*10.*",
+				"Settings.*party1.*ProtocolRef.*protocol2.*ProgressRounds.*0.*10.*",
+				"Settings.*party1.*ProtocolRef.*protocol1.*ProgressRounds.*0.*12.*",
+				"Settings.*party2.*ProtocolRef.*protocol1.*ProgressRounds.*0.*12.*",
+				"Settings.*party1.*ProtocolRef.*protocol1.*ProgressRounds.*0.*10.*");
+	}
+
+	@Test
+	public void smokeTest() throws URISyntaxException {
+		new PartyRef(new URI("ws:localhost"));
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void nullTest() throws URISyntaxException {
+		new PartyRef((URI) null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+
+		String json = jackson.writeValueAsString(negoinfo1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		Settings p = (Settings) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(negoinfo1, p);
+	}
+
+	@Test
+	public void testGeneralDict()
+			throws JsonParseException, JsonMappingException, IOException {
+		Map val = jackson.readValue("{\"a\":0.3,\"b\":{\"x\":3},\"c\":[1,2,3]}",
+				HashMap.class);
+		System.out.println(val);
+	}
+
+}
